<template>
  <div
    v-if="user!=null && user.canCreateUser"
    class="container container-with-menu"
  >
    <h1><users-icon />Ajouter un utilisateur</h1>
    <hr>
    <div
      class="row"
    >
      <div
        class="col-md-12"
        style="margin-bottom: 1vh;"
      >
        <click-button
          @click="$router.push({'path':'/utilisateurs'})"
        >
          <template slot="content">
            Gérer les utilisateurs
          </template>
        </click-button>
      </div>
    </div>
    <form
      id="childForm"
      novalidate="novalidate"
    >
      <div class="row">
        <div class="col-xs-12 col-md-6">
          <div class="form-group required">
            <label
              for="email"
            >Email&nbsp;:</label>
            <input
              id="email"
              v-model="email"
              name="email"
              type="email"
              class="form-control"
              required="required"
            >
          </div>
          <p><b><span style="color: red;">* </span>Permissions :</b></p>
          <div class="form-group">
            <div class="row">
              <div class="col-xs-6">
                <label for="canCreateUser">Créer des utilisateurs&nbsp;:</label>
              </div>
              <div class="col-xs-6">
                <input
                  id="canCreateUser"
                  v-model="canCreateUser"
                  name="canCreateUser"
                  type="checkbox"
                >
              </div>
            </div>
          </div>
          <div class="form-group">
            <div class="row">
              <div class="col-xs-6">
                <label for="canAccessData">Accéder au tableau de bord&nbsp;:</label>
              </div>
              <div class="col-xs-6">
                <input
                  id="canAccessData"
                  v-model="canAccessData"
                  name="canAccessData"
                  type="checkbox"
                >
              </div>
            </div>
          </div>
          <div class="form-group">
            <div class="row">
              <div class="col-xs-6">
                <label for="canUploadDsnFile">Ajouter des fichiers DSN&nbsp;:</label>
              </div>
              <div class="col-xs-6">
                <input
                  id="canUploadDsnFile"
                  v-model="canUploadDsnFile"
                  name="canUploadDsnFile"
                  type="checkbox"
                >
              </div>
            </div>
          </div>
        </div>
        <div class="col-xs-12 col-md-6">
          <div class="form-group required">
            <label
              for="dsnpRoles"
            >Rôle&nbsp;:</label>
            <select
              id="dsnpRoles"
              v-model="dsnpRole"
              name="dsnpRole"
              class="form-control"
              required="required"
            >
              <option value="admindsnp">
                Administrateur
              </option>
              <option value="grouperh">
                Responsable des ressources humaines
              </option>
              <option value="partenaire">
                Membre du comité sociale de l’entreprise
              </option>
            </select>
            <br>
            <i><u><b>Administrateur</b></u> :<br> Accède à toutes les données issues des fichiers DSN et peut créer des Index d'égalité Femmes-Hommes ainsi que des BDES.</i><br><br>
            <i><u><b>Responsable des ressources humaines</b></u> :<br> Accède à toutes les données issues des fichiers DSN.</i><br><br>
            <i><u><b>Membre du comité social de l’entreprise</b></u> :<br> Accède seulement au données agrégées et aux résultats des index d’égalité femmes-hommes et des BDES.</i>
          </div>
        </div>
      </div>
      <div
        v-if="canAccessData"
        class="row"
        style="margin-top: 1em;"
      >
        <div
          class="col-xs-12"
          style="display: flex; flex-direction: column;"
        >
          <label style="text-align: center;">Entreprise(s)* et groupement(s) autorisés sur les tableaux de bord</label>
          <el-transfer
            v-model="selectedSirensAndGroups"
            style="margin: auto; width: 100%;"
            :data="availableSirensAndGroups"
            :titles="['Disponible(s)', 'Autorisée(s)']"
            :props="{
              key: 'id',
              label: 'name'
            }"
          />
        </div>
      </div>
      <br>
      <div class="row">
        <div
          class="form-group btn-list"
        >
          <click-button
            :disabled="submitDisabled"
            @click="performChild()"
          >
            <template slot="content">
              Créer un nouvel utilisateur
            </template>
          </click-button>
        </div>
        <div>
          <sub>*issue(s) de fichier(s) dsn importé(s)</sub>
        </div>
      </div>
    </form>
  </div>
  <div
    v-else
    class="container-with-menu"
  >
    Vous n'avez pas la permission requise pour gérer des utilisateurs.
  </div>
</template>

<script>
import UsersIcon from '../../../components/Icon/UsersIcon'
import {mapActions, mapGetters} from 'vuex'
import VanillaToasts from 'vanillatoasts'
import ClickButton from "../../../components/Button/ClickButton";

export default {
  name: "AddChild",
  components: {ClickButton, UsersIcon},
  data() {
    return {
      selectedSirensAndGroups: [],
      availableSirensAndGroups: [],
      validator: null,
      email: '',
      canCreateUser: false,
      canAccessData: false,
      canUploadDsnFile: false,
      editedChildIndex: null,
      dsnpRole: 'admindsnp'
    }
  },
  computed: {
    selectedSirensIds: function() {
      return this.selectedSirensAndGroups.filter(item => typeof item  == "number")
    },
    selectedSirens:function() {
      return this.availableSirensAndGroups.filter(item => this.selectedSirensIds.includes(item.id))
    },
    selectedGroupsIds: function() {
      return this.selectedSirensAndGroups.filter(item => typeof item  == "string")
    },
    selectedGroups: function() {
      return this.availableSirensAndGroups.filter(item => this.selectedGroupsIds.includes(item.id))
    },
    submitDisabled: function() {
      if(this.canAccessData === false) {
        return this.isLoading || this.email.length === 0 || ( this.canCreateUser === false
            && this.canAccessData === false && this.canUploadDsnFile === false );
      }else {
        return this.isLoading || this.email.length === 0 || ( this.canCreateUser === false
            && this.canAccessData === false &&this.canUploadDsnFile === false ) 
            || this.selectedSirensAndGroups.length === 0;
      }
    },
    ...mapGetters([
      'sirens',
      'groups',
      'isLoading',
      'user'
    ])
  },
  created() {
    this.fetchSirens().then(()=>{
      this.sirens.forEach(siren => {
        this.availableSirensAndGroups.push(siren)
      })
    })
    this.fetchGroups().then(()=>{
      this.groups.forEach(group => {
        this.availableSirensAndGroups.push(group)
      })
    })
  },
  mounted() {
    this.validator = $('#childForm').submit(function (e) {
      e.preventDefault();
    }).validate({
      rules: {
        email: {
          required: true,
          email: true
        },
        sirens: {
          required: true
        }
      },
      errorElement: 'em',
      errorPlacement: function (error, element) {
        // Add the `help-block` class to the error element
        error.addClass('help-block');

        if (element.prop("type") === 'checkbox') {
          error.insertAfter(element.parent('label'));
        } else {
          error.insertAfter(element);
        }
      },
      highlight: function (element) {
        $(element).parents(".form-group").addClass("has-error").removeClass("has-success");
      },
      unhighlight: function (element) {
        $(element).parents(".form-group").addClass("has-success").removeClass("has-error");
      }
    });
  },
  methods: {
    ...mapActions([
      'fetchSirens',
      'fetchGroups',
      'createChild',
      'loadingStarts',
      'loadingEnds'
    ]),
    performChild() {
      if ($("#childForm").valid()) {
        this.loadingStarts()
        this.createChild({
          email: this.email,
          sirens: this.selectedSirens,
          groups: this.selectedGroups,
          canCreateUser: this.canCreateUser,
          canAccessData: this.canAccessData,
          canUploadDsnFile: this.canUploadDsnFile,
          dsnpRole: this.dsnpRole
        }).then(()=>{
          VanillaToasts.create({
            title: 'Ajout utilisateur',
            text: 'Compte utilisateur créé avec succès.<br>' +
                'Un mail d\'activation de compte a été envoyé.',
            type: 'success',
            timeout: 10000,
          });
          this.loadingEnds()
          this.$router.push({ path: '/utilisateurs'})
        })
      }
    }
  }
}
</script>

<style scoped>
</style>